clear all 
close all 
clc 

%========================================================================
% Simulating Random Sampling 
%========================================================================
path(path,'C:\Users\NJN\Dropbox\IEEE_BIG_DATA_PROJECT\FontData')

            %---------- Initialize and Generate Random Image (Not from Source Images)
            S=35 ;  % Number of Sources
            C=10;   % Number of Characters 
            NumExp=50; % Number of Experiments to Run 
            MaxImag=84; % Max Number of Sources Available in the Data Base 
            RC = randi([1,10],[1 NumExp]); % Vector of Characters 
            RS = randi([S+1,MaxImag],[1 NumExp]);  % Vector of Soruces 
            NJN=1;          % Indexer for Random Images 
            
            % ---------------------- Picking Random Image ---------------------------------- 
                        if RC(NJN)<10
                          BScript=['img00' num2str(RC(NJN)) '-000' num2str(RS(NJN)) '.png'];
                        elseif RC(NJN)>9 % For the additional 10th image 
                           BScript=['img0' num2str(RC(NJN)) '-000' num2str(RS(NJN)) '.png'];
                        end 
            %-------------------------Getter and Setter (Global Variable)----------------------------------       
                 SetGlobal(imread(BScript))  % (1st number of the font class / second number is the character)
                 r = getGlobalx;

%========================================================================
% MapReduce Process 
%========================================================================

ds = datastore('C:\Users\NJN\Dropbox\IEEE_BIG_DATA_PROJECT\MatlabAnalysis\MapReduceWork\SourcesDataCSVFiles\*.csv');

maxDelay = mapreduce(ds, @CorrDSMapper, @DSFusionReducer);