<?php

$noises = array(
    10,
    30,
    50,
    70,
    90
);

$mysourcecounts = array (
    8,
    98,
    188,
    278,
    368,
//    458,
//    548,
//    638,
//    728,
//    818,
//    908,
//    998
);


$things = array(
   '0',
   '1',
   '2',
   '3',
   '4',
   '5',
   '6',
   '7',
   '8',
   '9',
   'a',
   'b',
   'c',
   'd',
   'e',
   'f',
   'g',
   'h',
   'i',
   'j',
   'k',
   'l',
   'm',
   'n',
   'o',
   'p',
   'q',
   'r',
   's',
   't',
   'u',
   'v',
   'w',
   'x',
   'y',
   'z'
);


$score = array();
$times = array();
$unc   = array();


$trueuncs = array();
$falseuncs= array();

$count=0;
foreach($noises as $thenoise) {
  foreach ($mysourcecounts as $src) {
//    if (++$count > 5)
  //    break;
    $compile_command = 'gcc -o myparallel2 -O2 -DNUMSOURCE='.$src.' parallel.c dempster.c -lm -lpthread -Wno-unused-result';
    shell_exec($compile_command);
    $score[$src] =0;
    $times[$src] = array();
    $unc[$src] = array();

    $trueuncs[$src] = array();
    $falseuncs[$src]= array();

    $mismatches='';

    $output = '';

    print "Trying with source count ".$src."\n";
    for ($i=0; $i<999; $i++) {
     //   $mysrc = mt_rand(0, 998); 
        $mysrc=$i;
        $mychar= mt_rand(0, 35);

        unset($lines);


        exec('./myparallel2 '.$mysrc.' '.$mychar.' '.$thenoise, $lines);

        list($garbage, $time) = explode(':', $lines[0]);

        $time = trim($time);

        $success =0;
        $fail =0;
        $max = 0;
        $thechar = 0;
  //      print "Need char $mychar.\n";
        for ($j=1; $j<=36; $j++) {
            list ($char, $mass) = explode("\t", $lines[$j]);

            if (floatval($mass) > $max) {
                $max = $mass;
                $thechar = $j-1;
            }
//            print "char $char (".$things[$char]."): $mass\n";
        }
        list ($char, $uncertainty) = explode("\t", $lines[$j]);

       // $output.="$thechar\t".$things[$thechar]."\t$max\t$uncertainty\t$mychar\t".$things[$mychar]."\t$mysrc\n";
        

        if ($thechar == $mychar) {
            $trueuncs[$src][] = $uncertainty;

            $score[$src]++;
        } else {
            $falseuncs[$src][] = $uncertainty;
            $mismatches .= $mysrc . ':'.$mychar . ':' . $things[$mychar] . ':'.$thechar.':'.$things[$thechar]."\n";
        }
        
        $times[$src][] = $time;
        $unc[$src][] = $uncertainty;

        //print "#SRC:$src SRC:$mysrc CHR:$mychar SUC:$success FAL:$fail\n";

        $output .= "$mychar,$thechar,$uncertainty,$max,$thenoise,$src,$mysrc\n";
    }

    $file = fopen('./exp-results/output-'.$src.'-'.$thenoise.'.txt', "w+");
    fwrite($file, $output);
    fclose($file);

/*
    $file = fopen('./exp-results/output-'.$src.'.txt', "w+");
    fwrite($file, $output);
    fclose($file);

    $file = fopen('./exp-results/mismatches-'.$src.'.txt', "w+");
    fwrite($file, $mismatches);
    fclose($file);

    $file = fopen('./exp-results/trueuncertainty-'.$src.'.txt', "w+"); 
    foreach ($trueuncs[$src] as $thisunc) {
        fwrite($file, $thisunc."\n");
    }
    fclose($file);

    $file = fopen('./exp-results/falseuncertainty-'.$src.'.txt', "w+"); 
    foreach ($falseuncs[$src] as $thisunc) {
        fwrite($file, $thisunc."\n");
    }
    fclose($file);
 */


   // print "#SRC:$src SRC:$mysrc CHR:$mychar SUC:$success FAL:$fail\n";
  }
}
/*
$scorefile = fopen('./exp-results/score.txt', 'w+');

foreach($mysourcecounts as $src) {
    fwrite($scorefile, $src . ', '. $score[$src]."\n");
}

fclose($scorefile);

foreach($times as $key=>$value) {
    $file = fopen('./exp-results/times-'.$key.'.txt', 'w+');
    $file2 = fopen('./exp-results/uncs-'.$key.'.txt', 'w+');
    for ($i=0; $i<count($value); $i++) {
        fwrite($file, $value[$i]."\n");
        fwrite($file2, $unc[$key][$i]."\n");
    }
    fclose($file);
    fclose($file2);
}
 */
//print_r($score);
//print_r($times);
?>
