#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int noise;

    unsigned char images[5420][10][28*28];
inline int myrand (int min, int max) {
    return min + rand() / (RAND_MAX / (max - min) + 1);
}


void addNoise(unsigned char * img) {
    int i, therand;
    for (i=0; i<28*28; i++) {
        therand = myrand(0, 100);
        if (therand < noise) {
            if (rand()%2==0)
                img[i]=0;
            else
                img[i]=255;
        }
    }
}


int main (int argc, char ** argv) {
    int i,j;
    char f1[256], f2[256];
    FILE *fp1, *fp2;

    if (argc<2) {
        printf("Usage: ./noise T\n");
        exit(1);

    }

    noise = atoi(argv[1]);

    printf("%d\n", noise);

    for (i=5420; i<5421; i++) {
        for (j=0; j<10; j++) {
            sprintf(f1, "./font-dump/img-%d-%d.dat", j, i); 
            sprintf(f2, "./font-dump-noise-%d/img-%d-%d.dat", noise, j, i);
            fp1 = fopen(f1, "rb");
            fp2 = fopen(f2, "wb");
            if (!fp1 || !fp2) {
                perror("error");
                printf("%s\n%s\n", f1, f2);
                continue;
            }
            fread(images[0][j], sizeof(unsigned char), 28*28, fp1);
            addNoise(images[0][j]);
            fwrite(images[0][j], sizeof(unsigned char), 28*28, fp2);
            fclose(fp1);
            fclose(fp2);
        }
    }

    return 0;
}
