#!/usr/bin/octave -qW

arg_list=argv();

filename = "/home/kleach/nickdata/MapReduceWork/redux/timing-corrected.txt";
outfile = "/home/kleach/nickdata/MapReduceWork/mytiming.png";

F=dlmread(filename, ",");

numsrc=F(:,1);
numcpus=F(:,2);
time=F(:,3);


s1=numcpus==1;
s2=numcpus==2;
s3=numcpus==3;
s4=numcpus==4;
s5=numcpus==8;
s6=numcpus==16;


figure
plot(numsrc(s1), time(s1), "r;1 cpu;")
hold on
plot(numsrc(s2), time(s2), "g;2 cpu;")
plot(numsrc(s3), time(s3), "b;3 cpu;")
plot(numsrc(s4), time(s4), "m;4 cpu;")
plot(numsrc(s5), time(s5), "c;8 cpu;")
plot(numsrc(s6), time(s6), "k;18 cpu;")


saveas(1, outfile)
