function CorrDSMapper( Source, info, intermKVStore)
%Mapper function for DSFusionReducer. 


%---------- Initialize Values ----------------
load ImageHolder % Pull Global Template 
Source=Source{:,:}; % Convert Source Table to a Double
NT=length(SimImage(:,1)); % Length of Template (Assumption that templates and Sources Images Dimensions are Equal) 
NS=round(length(Source(:,1))/NT) ;% Number of the Sources Images 

%------------Correlation Vector-----------
        for i=1:NS
            V(i)=corr2(Source(1+NT*(i-1):i*NT,:),SimImage);
        end   
           [DSMass]= DSmassC(V);  % OLD Function ... Need to find the correction function without errors 
%-----------Key Value Stores -------------
add(intermKVStore,'key',DSMass)

end

