function [ MassC ] = DCRsingletons(Mass1, Mass2 )
%This will fuse two mass vectors with only singeltons. Each elment location
%is associated to a specific proposition. 


%-------------Template----------------------
N=length(Mass1);
I=eye(N);
I(N,:)=ones(1,N); 
I(:,N)=ones(N,1);
%--------------------------------------------


CombMatrix=Mass1*Mass2';

ElemMatrix=I.*CombMatrix; % Intersections

Norm=sum(sum(ElemMatrix)); % Sum of the X 


        for i=1:N-1
           MassC(i)= (CombMatrix(i,i)+CombMatrix(i,N)+CombMatrix(N,i))  / (Norm);
        end   
        
MassC(N)=(CombMatrix(N,N)) / (Norm); 


end

