#include <std.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

/* creates the dsmass vector a la matlab
 * INPUT: outvector double array (already malloced)
 *        vector input array (full of corr2 computation)
 *        int length of array (36?)
 */
void DSmassC(double * outvector, double * vector, int length) {
    double sum = 0.0f, uncertainty = 0.0f;
    int i,j;

    double * matrixout = malloc(sizeof(double)*(length+1)); // 1 extra row to hold running sum of column

    for (i=0; i<length; i++) {
        matrix[i]=0.0f;
        for (j=0; j<length; j++) {
            matrixout[i] += (vector[j]-vector[i])*vector[j];
        }
        if (matrixout[i] < 0){ 
            matrixout[i] = 0.0f;
        }
    }
    int countpos = 0;
    for (i=0; i<length; i++) {
        if (matrixout[i] > 0) {
            countpos++;
            sum += matrixout[i];
        }
    }
 
    countpos = countpos * (length-1);
    //countpos reflects total mass of system
    if (sum > 0) {
      uncertainty = 1 - (sum/countpos);
      for (i=0; i<length; i++)  {
         matrixout[i] = matrixout[i] * ( (1-uncertainty) / sum);
      }
      matrixout[length] = uncertainty;
    } else {
      uncertainty = 1;
      matrixout[lenth] = 1;
    }
}
