#!/usr/bin/octave -qfW

arg_list=argv();

filename = "./summary-0.txt";
filename2 = "./summary-10.txt";
filename3 = "./summary-30.txt";
filename4 = "./summary-50.txt";
filename5 = "./summary-70.txt";
filename6 = "./summary-90.txt";
outfile = "./myfig.png";


F=dlmread(filename, ",");
F2=dlmread(filename2, ",");
F3=dlmread(filename3, ",");
F4=dlmread(filename4, ",");
F5=dlmread(filename5, ",");
F6=dlmread(filename6, ",");

% noiselevel = F(:,1);
% numsrc   = F(:,2);
% tscore = F(:,3);
% fscore = F(:,4);

numsrc   = F(:,1);
score    = F(:,2);
bad      = F(:,3);
avgtime  = F(:,4);
stdtime  = F(:,5);
avgtmass = F(:,6);
stdtmass = F(:,7);
avgfmass = F(:,8);
stdfmass = F(:,9);
avgmass  = F(:,10);
stdmass  = F(:,11);
avgtunc  = F(:,12);
stdtunc  = F(:,13);
avgfunc  = F(:,14);
stdfunc  = F(:,15);
avgunc   = F(:,16);
stdunc   = F(:,17);

  numsrc2     = F2(:,1);
   score2     = F2(:,2);
     bad2     = F2(:,3);
 avgtime2     = F2(:,4);
 stdtime2     = F2(:,5);
avgtmass2     = F2(:,6);
stdtmass2     = F2(:,7);
avgfmass2     = F2(:,8);
stdfmass2     = F2(:,9);
 avgmass2     = F2(:,10);
 stdmass2     = F2(:,11);
 avgtunc2     = F2(:,12);
 stdtunc2     = F2(:,13);
 avgfunc2     = F2(:,14);
 stdfunc2     = F2(:,15);
  avgunc2     = F2(:,16);
  stdunc2     = F2(:,17);

  numsrc3     = F3(:,1);
   score3     = F3(:,2);
     bad3     = F3(:,3);
 avgtime3     = F3(:,4);
 stdtime3     = F3(:,5);
avgtmass3     = F3(:,6);
stdtmass3     = F3(:,7);
avgfmass3     = F3(:,8);
stdfmass3     = F3(:,9);
 avgmass3     = F3(:,10);
 stdmass3     = F3(:,11);
 avgtunc3     = F3(:,12);
 stdtunc3     = F3(:,13);
 avgfunc3     = F3(:,14);
 stdfunc3     = F3(:,15);
  avgunc3     = F3(:,16);
  stdunc3     = F3(:,17);

  numsrc4     = F4(:,1);
   score4     = F4(:,2);
     bad4     = F4(:,3);
 avgtime4     = F4(:,4);
 stdtime4     = F4(:,5);
avgtmass4     = F4(:,6);
stdtmass4     = F4(:,7);
avgfmass4     = F4(:,8);
stdfmass4     = F4(:,9);
 avgmass4     = F4(:,10);
 stdmass4     = F4(:,11);
 avgtunc4     = F4(:,12);
 stdtunc4     = F4(:,13);
 avgfunc4     = F4(:,14);
 stdfunc4     = F4(:,15);
  avgunc4     = F4(:,16);
  stdunc4     = F4(:,17);

  numsrc5     = F5(:,1);
   score5     = F5(:,2);
     bad5     = F5(:,3);
 avgtime5     = F5(:,4);
 stdtime5     = F5(:,5);
avgtmass5     = F5(:,6);
stdtmass5     = F5(:,7);
avgfmass5     = F5(:,8);
stdfmass5     = F5(:,9);
 avgmass5     = F5(:,10);
 stdmass5     = F5(:,11);
 avgtunc5     = F5(:,12);
 stdtunc5     = F5(:,13);
 avgfunc5     = F5(:,14);
 stdfunc5     = F5(:,15);
  avgunc5     = F5(:,16);
  stdunc5     = F5(:,17);

  numsrc6     = F6(:,1);
   score6     = F6(:,2);
     bad6     = F6(:,3);
 avgtime6     = F6(:,4);
 stdtime6     = F6(:,5);
avgtmass6     = F6(:,6);
stdtmass6     = F6(:,7);
avgfmass6     = F6(:,8);
stdfmass6     = F6(:,9);
 avgmass6     = F6(:,10);
 stdmass6     = F6(:,11);
 avgtunc6     = F6(:,12);
 stdtunc6     = F6(:,13);
 avgfunc6     = F6(:,14);
 stdfunc6     = F6(:,15);
  avgunc6     = F6(:,16);
  stdunc6     = F6(:,17);





figure;
hold on
plot(numsrc, avgtmass, 'b', 'LineWidth', 4);
plot(numsrc, avgfmass, 'b', 'LineWidth', 2, 'linestyle', '--');

%plot(numsrc2, avgtmass2, 'b', 'LineWidth', 1, 'linestyle', '--');
%plot(numsrc2, avgfmass2, 'r', 'LineWidth', 1, 'linestyle', '--');

plot(numsrc3, avgtmass3, 'k', 'LineWidth', 4, 'linestyle', '-');
plot(numsrc3, avgfmass3, 'k', 'LineWidth', 2, 'linestyle', '--');

plot(numsrc4, avgtmass4, 'c', 'LineWidth', 4, 'linestyle', '-');
plot(numsrc4, avgfmass4, 'c', 'LineWidth', 2, 'linestyle', '--');

plot(numsrc5, avgtmass5, 'g', 'LineWidth', 4);
plot(numsrc5, avgfmass5, 'g', 'LineWidth', 2, 'linestyle', '--');

%plot(numsrc6, avgtmass6, 'b', 'LineWidth', 1);
%plot(numsrc6, avgfmass6, 'r', 'LineWidth', 1);

axis([0, 1000])
l=legend(
    "Belief when predicted correctly", 
    "Belief when predicted incorrectly", 
    "Belief when predicted correctly (30\\% noise)", 
    "Belief when predicted incorrectly (30\\% noise)",
    "Belief when predicted correctly (50\\% noise)", 
    "Belief when predicted incorrectly (50\\% noise)", 
    "Belief when predicted correctly (70\\% noise)", 
    "Belief when predicted incorrectly (70\\% noise)", 
    "location", "southoutside");
%h1 = errorbar(numsrc, avgtmass, stdtmass/sqrt(1000), 'b')
%h2 = errorbar(numsrc, avgfmass, stdfmass/sqrt(1000), 'r') 
xlabel("Number of Sources")
ylabel("Belief")

%set (l, "fontsize", 6)

saveas(1, outfile)
print("myfig.tex", "-dtikz", "-S1280,900")


figure;
hold on
plot(numsrc, avgtmass, 'b', 'LineWidth', 4);
plot(numsrc, avgfmass, 'b', 'LineWidth', 2, 'linestyle', '--');

%plot(numsrc2, avgtunc2, 'b', 'LineWidth', 1, 'linestyle', '--');
%plot(numsrc2, avgfunc2, 'r', 'LineWidth', 1, 'linestyle', '--');

plot(numsrc3, avgtmass3, 'k', 'LineWidth', 4, 'linestyle', '-');
plot(numsrc3, avgfmass3, 'k', 'LineWidth', 2, 'linestyle', '--');

plot(numsrc4, avgtmass4, 'c', 'LineWidth', 4, 'linestyle', '-');
plot(numsrc4, avgfmass4, 'c', 'LineWidth', 2, 'linestyle', '--');

plot(numsrc5, avgtmass5, 'g', 'LineWidth', 4);
plot(numsrc5, avgfmass5, 'g', 'LineWidth', 2, 'linestyle', '--');

%plot(numsrc6, avgtmass6, 'b', 'LineWidth', 1);
%plot(numsrc6, avgfmass6, 'r', 'LineWidth', 1);

axis([0, 1000])

l=legend(
    "Uncertainty when predicted correctly", 
    "Uncertainty when predicted incorrectly", 
    "Uncertainty when predicted correctly (30\\% noise)", 
    "Uncertainty when predicted incorrectly (30\\% noise)",
    "Uncertainty when predicted correctly (50\\% noise)", 
    "Uncertainty when predicted incorrectly (50\\% noise)", 
    "Uncertainty when predicted correctly (70\\% noise)", 
    "Uncertainty when predicted incorrectly (70\\% noise)", 
    "location", "southoutside");
%h1 = errorbar(numsrc, avgtmass, stdtmass/sqrt(1000), 'b')
%h2 = errorbar(numsrc, avgfmass, stdfmass/sqrt(1000), 'r') 
xlabel("Number of Sources")
ylabel("Uncertainty")

set (l, "fontsize", 6)

saveas(1, outfile)
print("myfig2.tex", "-dtikz", "-S1280,900")




%figure;
%hold on
%plot(numsrc, avgtunc)
%plot(numsrc, avgfunc)

saveas(2, "./myfig2.png")






